Attribute VB_Name = "HTTP_OPs"
Option Explicit

Public Function GetFullAddress(ByVal NewAddress As String, ByVal OldAddress As String) As String
 If NewAddress = "" Then Exit Function
 Replace NewAddress, "\", "/"
 If InStr(NewAddress, ":") <> 0 Then
  GetFullAddress = NewAddress
 Else
  If Left$(NewAddress, 1) = "/" Then
   GetFullAddress = GetMainURL(OldAddress) + NewAddress
  Else
   Dim Temp As String
   Dim F As Long
   Temp = GetAktDirURL(OldAddress)
   
CheckAgain:
   If AZLeftGleich(NewAddress, "..") Then
    Temp = GetAktDirURL(Left$(Temp, Len(Temp) - 1))
    NewAddress = Right$(NewAddress, Len(NewAddress) - 2)
    F = InStr(NewAddress, "/")
    If F <> 0 Then
     NewAddress = Right$(NewAddress, Len(NewAddress) - F)
     GoTo CheckAgain
    End If
   End If
   If AZLeftGleich(NewAddress, ".") Then
    NewAddress = Right$(NewAddress, Len(NewAddress) - 1)
    F = InStr(NewAddress, "/")
    If F <> 0 Then
     NewAddress = Right$(NewAddress, Len(NewAddress) - F)
     GoTo CheckAgain
    End If
   End If
   F = InStr(NewAddress, "/")
   If F <> 0 Then
    Temp = Temp + Left$(NewAddress, F)
    NewAddress = Right$(NewAddress, Len(NewAddress) - F)
    GoTo CheckAgain
   End If
   
   GetFullAddress = Temp + NewAddress
  End If
 End If
End Function

Public Function GetMainURL(ByVal TheAddress As String) As String
 Replace TheAddress, "\", "/"
 If Len(TheAddress) >= 7 Then
  If UCase$(Left$(TheAddress, 7)) = "HTTP://" Then
   TheAddress = Right$(TheAddress, Len(TheAddress) - 7)
  End If
 End If
 Dim F As Integer
 F = InStr(TheAddress, "/")
 If F Then
  TheAddress = Left$(TheAddress, F - 1)
 End If
 GetMainURL = "http://" + TheAddress
End Function

Public Function GetAktDirURL(ByVal TheAddress As String) As String
 Replace TheAddress, "\", "/"
 If Len(TheAddress) >= 7 Then
  If UCase$(Left$(TheAddress, 7)) = "HTTP://" Then
   TheAddress = Right$(TheAddress, Len(TheAddress) - 7)
  End If
 End If
 Dim X As Integer
 X = Len(TheAddress)
 Do While X > 0
  If Mid$(TheAddress, X, 1) = "/" Then
   GetAktDirURL = "http://" + Left$(TheAddress, X)
   Exit Function
  End If
  X = X - 1
 Loop
 GetAktDirURL = "http://" + TheAddress + "/"
End Function

Public Function Convert_Text_To_PostData(ByVal TheText As String) As String
 TheText = Replace(TheText, " ", "+")
 
 Convert_Text_To_PostData = TheText
End Function

Public Function LinkIsCorrect(ByVal TheLink As String) As Boolean
 TheLink = UCase$(TheLink)
 If Len(TheLink) > 7 Then
  If Left$(TheLink, 7) = "HTTP://" Then
   LinkIsCorrect = True
   Exit Function
  End If
 End If
 LinkIsCorrect = False
End Function

Public Function GetServerFromURL(ByVal URL As String) As String
 URL = UCase$(Replace(URL, "\", "/"))
 If AZLeftGleich(URL, "HTTP://") Then URL = Right$(URL, Len(URL) - 7)
 Dim F As Long
 F = InStr(URL, "/")
 If F <> 0 Then URL = Left$(URL, F - 1)
 F = InStr(URL, ":")
 If F = 0 Then URL = URL + ":80"
 
 GetServerFromURL = URL
End Function

Public Function IPisOK(ByVal IP As String) As Boolean
 Dim F As Long
 IPisOK = False
 
 F = InStr(IP, ".")
 If F = 0 Then Exit Function
 If Not IsZahl(Left$(IP, F - 1), "") Then Exit Function
 If (Val(Left$(IP, F - 1)) < 0) Or _
    (Val(Left$(IP, F - 1)) > 255) Then Exit Function
 IP = Right$(IP, Len(IP) - F)
 
 F = InStr(IP, ".")
 If F = 0 Then Exit Function
 If Not IsZahl(Left$(IP, F - 1), "") Then Exit Function
 If (Val(Left$(IP, F - 1)) < 0) Or _
    (Val(Left$(IP, F - 1)) > 255) Then Exit Function
 IP = Right$(IP, Len(IP) - F)
 
 F = InStr(IP, ".")
 If F = 0 Then Exit Function
 If Not IsZahl(Left$(IP, F - 1), "") Then Exit Function
 If (Val(Left$(IP, F - 1)) < 0) Or _
    (Val(Left$(IP, F - 1)) > 255) Then Exit Function
 IP = Right$(IP, Len(IP) - F)
 
 If Not IsZahl(IP, "") Then Exit Function
 If (Val(IP) < 0) Or _
    (Val(IP) > 255) Then Exit Function
 
 IPisOK = True
End Function
