Attribute VB_Name = "Mathe_Code"
Option Explicit

Public Declare Function timeGetTime Lib "winmm.dll" () As Long

Public Declare Function GetCursorPos Lib "user32" _
        (lpPoint As POINTAPI) As Long
        
Public Declare Function ClientToScreen Lib "user32" _
        (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
        
Public Type POINTAPI
  X As Long
  Y As Long
End Type

Public Type Point
 X As Double
 Y As Double
End Type

Public Type Position
 Stelle As Point
 Width As Double
 Height As Double
End Type

Public Function Betrag(ByVal Zahl As Double) As Double
 If Zahl < 0 Then
  Betrag = -Zahl
 Else
  Betrag = Zahl
 End If
End Function

Public Function TheBiggest(ByVal Zahl1 As Double, ByVal Zahl2 As Double) As Double
 If Zahl1 > Zahl2 Then
  TheBiggest = Zahl1
 Else
  TheBiggest = Zahl2
 End If
End Function

Public Function GetProzent(ByVal Wert As Double) As String
 GetProzent = LTrim$(RTrim$(Str$(Int(Wert * 1000) / 10))) + "%"
End Function

Public Function Zufall(ByVal Zahl1 As Long, ByVal Zahl2 As Long) As Long
 Dim Obergrenze As Long
 Dim Untergrenze As Long
 If Zahl1 > Zahl2 Then
  Obergrenze = Zahl1
  Untergrenze = Zahl2
 Else
  Obergrenze = Zahl2
  Untergrenze = Zahl1
 End If
 Zufall = Int((Obergrenze - Untergrenze + 1) * Rnd + Untergrenze)
End Function

Public Function Point2String(ThePoint As Point) As String
 Point2String = LTrim$(RTrim$(Str$(ThePoint.X))) + "|" + _
                LTrim$(RTrim$(Str$(ThePoint.Y)))
End Function

Public Function String2Point(ByVal TheString As String) As Point
 Dim F As Long
 F = InStr(TheString, "|")
 If F = 0 Then Exit Function
 String2Point.X = Val(Left$(TheString, F - 1))
 String2Point.Y = Val(Right$(TheString, Len(TheString) - F))
End Function

Public Function GetPoint(ByVal X As Double, ByVal Y As Double) As Point
 GetPoint.X = X
 GetPoint.Y = Y
End Function

Public Function GetPosition(ThePoint As Point, TheWidth As Double, TheHeight As Double) As Position
 GetPosition.Stelle = ThePoint
 GetPosition.Width = TheWidth
 GetPosition.Height = TheHeight
End Function

Public Function Position2String(ThePosition As Position) As String
 Position2String = Point2String(ThePosition.Stelle) + "_" + _
                   LTrim$(RTrim$(Str$(ThePosition.Width))) + "|" + _
                   LTrim$(RTrim$(Str$(ThePosition.Height)))
End Function

Public Function String2Position(ByVal TheString As String) As Position
 Dim F As Long
 F = InStr(TheString, "_")
 If F = 0 Then Exit Function
 String2Position.Stelle = String2Point(Left$(TheString, F - 1))
 String2Position.Width = String2Point(Right$(TheString, Len(TheString) - F)).X
 String2Position.Height = String2Point(Right$(TheString, Len(TheString) - F)).Y
End Function

Public Function IsZahl(ByVal Zahl As String, Optional ByVal Komma As String = ".") As Boolean
 Dim X As Long
 For X = 1 To Len(Zahl)
  Select Case Mid$(Zahl, X, 1)
   Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", Komma
    'Zeichen OK
   Case Else
    IsZahl = False
    Exit Function
  End Select
 Next
 IsZahl = True
End Function

Public Function ZwischenWert(ByVal Zahl1 As Double, ByVal Zahl2 As Double) As Double
 If Zahl1 > Zahl2 Then
  ZwischenWert = Zahl2 + (Zahl1 - Zahl2) / 2
 Else
  ZwischenWert = Zahl1 + (Zahl2 - Zahl1) / 2
 End If
End Function
